
unit Transpan;
{

 TTransPan component for Borland DELPHI 1.0, Version 1.00.
     Freeware.
 (C) Alexander Gogava, Tbilisi, Rep. of Georgia. October 1997.
     E - mail   alex@argosoft.com

 This component can be use like the TPanel in all applications, because
 It has all published and public properties of  the TPanel,
 but user mast know some secrets:
 1. Press Ctrl and RightClick TTransPan to transform it from Panel to Scramble.
    Now user can resize, drag and drop it, and play scramble;
 2. Press Ctrl and RightClick enabled button in Scramble to change
    level of game;
 3. RightClick enabled button in scramble to restart level;
 4. Drag and drop Scramble in TTransPan using its free (black) space
    or disabled button,  Press Ctrl and RightClick TTransPan to
    transform it from Scramble to Panel.

 To install this component in your VCL place the files
 TRANSPAN.PAS, SCRMBL.PAS and TRANSPAN.DCR  in your
 C:\DELPHI\LIB directory and from IDE Options Menu select
 Install Components. In the Install Components dialogue
 box click Add Button, then in Add Module box type
 C:\DELPHI\LIB\TRANSPAN.PAS, click OK, then in the Install
 Components Dialogue box click OK again and wait  while
 TRansPan icon will appear in the Samples section of the
 your Components Palette.

 This unit is public domain. You can add/rewrite code, but
 if you do it, please, let me know. If you have any
 suggestions for improvements, or if you find any bugs,
 please notify the author.

 Regards

 Alexander Gogava

 alex@argosoft.com

}
interface
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Menus, Scrmbl;
type
  TState = (Panel, Scramble);
  TLevel = 1..2;
  TTransPan = class(TCustomPanel)
  private
    { Private declarations }
  protected
    i,j,fx,fy,fcx,fcy :Integer;
    FStyle: Longint;
    FState : TState;
    FLevel : TLevel;
    procedure SetState(Value: TState);
    procedure SetLevel(Value: TLevel);
    procedure ChangeState;
    procedure ChangeParams;
    procedure MouseDown
    (Button: TMouseButton; Shift: TShiftState; X,Y: Integer); Override;
    property State: Tstate read FState write SetState default Panel;
    property Level: TLevel read FLevel Write SetLevel default 1;
  public
    { Public declarations }
    Scrmbl1: TScrmbl;
    constructor Create (AOwner: TComponent); Override;
    destructor Destroy; Override;
 published
    property Align;
    property Alignment;
    property BevelInner;
    property BevelOuter;
    property BorderStyle;
    property BorderWidth;
    property Caption;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property Locked;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
  end;
procedure Register;

implementation
var
temp: String;

procedure Register;
begin
  RegisterComponents('Samples', [TTransPan]);
end;

constructor TTransPan.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
FState:=Panel;
FLevel:=1;
Caption:=Name;
Scrmbl1:=nil;
end;

Destructor TTransPan.Destroy;
begin
if ((FState=Scramble) and (Scrmbl1<>nil)) then Scrmbl1.Free;
inherited Destroy;
end;

procedure TTransPan.ChangeParams;
begin
 FStyle:=GetWindowLong(Handle,GWL_STYLE);
 FStyle:=FStyle xor WS_Caption xor WS_THICKFRAME;
 SetWindowLong(Handle, GWL_STYLE, FStyle);
 if FState=Panel then
 begin
 SetWindowPos(Handle, HWND_TOP, fx, fy, fcx, fcy, SWP_DRAWFRAME);
 end
 else
 begin
 fx:=Left; fy:=Top; fcx:=Width; fcy:=Height;
 SetWindowPos(Handle, HWND_TOP, 0, 0, 0, 0,
 SWP_NOMOVE or SWP_NOSIZE or SWP_NOZORDER or SWP_DRAWFRAME
 or SWP_NOACTIVATE);
 end;
end;

procedure TTransPan.ChangeState;
begin
if FState=Panel then
 begin
 Scrmbl1.Free;
 Scrmbl1:=nil;
 ChangeParams;
 end
else
 begin
 ChangeParams;
 temp:=Caption;
 Caption:='PLEASE WAIT';
 if Scrmbl1<>nil then Scrmbl1.Free;
 Scrmbl1:=TScrmbl.Create(Self);
     With Scrmbl1 do
     begin
     Parent:=Self;
     Align:=AlClient;
     Level:=FLevel;
     Caption:='';
     end;
 Caption:=temp;
 end;
end;

procedure TTransPan.SetState(Value: TState);
begin
if FState<>Value then
  begin
  FState:=Value;
  if (csDesigning in ComponentState)then exit;
  ChangeState;
  end;
end;

procedure TTransPan.SetLevel(Value: TLevel);
begin
  if ((FLevel=Value)or(FState=Panel)or(csDesigning in ComponentState))
  then exit;
  FLevel:=Value;
  Scrmbl1.Level:=FLevel;
end;

procedure TTransPan.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
inherited MouseDown(Button,Shift,X,Y);
if ((Button=mbRight) and (ssCtrl in Shift)) then
   if State=Scramble then State:=Panel else State:=Scramble;
end;

end.





